## -------------------------------------------------------------------------------------
#unha vez que se ten o codigo listo, e de cara a sacar un documento limpo podense inicializar uns
#parámetros, que me eviten a apariciónde avisos, a non ser que sexan erros 
knitr::opts_chunk$set(warning=FALSE)
knitr::opts_chunk$set(message=FALSE)
#que significa knitr::algo_mais?
#ese par de "dous puntos" indica que queremos usar un comando dun paquete 
#que non está subido á memoria con library. Só nos interesa puntualmente, 
#polo que só usamos ese comando con referencia ao nome do paquete


## -------------------------------------------------------------------------------------
#cargar librerias
library(ggplot2)
library(dplyr)
library(tibble)
library(tidyr)
library(forcats)
library(psych)
library(corrgram)
library(pastecs)
library(psych)
library(DescTools)


## -------------------------------------------------------------------------------------
ola=c(2,3,3,2,1,4)#creo un vector
dim(ola)#observo que non ten asignada dimensión
ola=matrix(ola,nrow = 3)#convirtoo nunha matriz con 3 liñas, polo tanto terá 2 columnas
dim(ola)#agora si ten dimensión
ola#aquí está a matriz


## -------------------------------------------------------------------------------------
# Elemento 2,2
ola[2,2]
# Fila 2
ola[2,]
#columna 1
ola[,1]
#neste caso non funciona se non se pon a coma
ola[1]#extrae o primeiro elemento, como se fose un vector, e non a primeira columna
#o mesmo para dobres corchetes
ola[[1]]


## -------------------------------------------------------------------------------------
#Unha matriz máis grande para filtros máis complexos
set.seed(2021)
matriz=matrix(rnorm(50),nrow = 10)
matriz[1:4,] # filas de primeira a cuarta
matriz[1:4,3] # 3ª columna das filas de primeira a cuarta
colMeans(matriz)# media por columnas
rowMeans(matriz)

matriz[,colMeans(matriz)>0]
matriz[rowMeans(matriz)>0,colMeans(matriz)>0]


## -------------------------------------------------------------------------------------
lista=list(8,3,"w","ola",data.frame(X=c(8,2,1),Y=c("a","b","c")))
lista


## -------------------------------------------------------------------------------------
#coma un vector
lista[4]# unha lista menor co 4º elemento da lista
lista[c(1,5)] # unha lista menor cos elementos 1 e 5 da lista

# coma un data.frame
lista[[4]] # O que hai dentro do 4º elemento da lista
lista[[5]] # o que hai dentro do 5º elemento da lista


## -------------------------------------------------------------------------------------
names(lista)=c("a","b","c","d","e")
lista$e
lista$a


## -------------------------------------------------------------------------------------
unlist(lista)
# En alguns casos, se hai compatibilidade, pode transformarse a lista nun data.frame
lista2=list(A=c(2,1,3),B=c("a","b","f"),C=c(2,4,1))
lista2
str(lista2)
df2=as.data.frame(lista2)
str(df2)


## -------------------------------------------------------------------------------------
### vectores
# Creo dous vectores para o exemplo
v1=c(2,1,2,3)
v2=c(2,2,3,4,5,4)
#pégoos usando c()
vv=c(v1,v2)
vv#isto é o que sae


## -------------------------------------------------------------------------------------
#preparar exemplos
mat1=matrix(1:40,nrow = 10)#crear unha matriz 10x4
dim(mat1)
mat2f=matrix(1:20,nrow = 10)#crear unha matriz 10x2
mat2c=matrix(1:20,ncol=4)#crear unha matriz 5x4


## -------------------------------------------------------------------------------------
### data.frames ou matrices
cbind(mat1,mat2f)#mesmo nº filas, o nº de columnas é suma de nº colmnas
rbind(mat1,mat2c)#mesmo nº columnas, o nº de filas é suma do nº filas


## -------------------------------------------------------------------------------------
datos0=read.csv2("membros2016.csv")
datos1=read.csv2("fogares2016.csv")
#con R básico: merge()
head(merge(datos0,datos1,by = "NUMERO"))#saco só os seus primeiros
#con dplyr: hai varios comandos "join"
datos=inner_join(datos0,datos1,"NUMERO")


## -------------------------------------------------------------------------------------
set.seed(43210)
X1=rnorm(100,2,0.5)# xerar 100 numeros aleatorios dunha N(2;0.5)
X2=runif(100,-1,1)# xerar 100 numeros aleatorios dunha Uniforme(-1;1)
X3=rchisq(100,9)# xerar 100 numeros aleatorios dunha chi con 9 graos de liberdade
Y=-3+2*X1-3*X2+0.5*X3+rnorm(100)# Xerar unha regresión a paartir das anteriores X
auxiliar=data.frame(Y,X1,X2,X3)
head(auxiliar)
summary(auxiliar)
apply(auxiliar,2,sd)


## -------------------------------------------------------------------------------------
plot(auxiliar$X1,auxiliar$Y,xlab=" Explicativa X1",ylab="Explicada Y",pch=20,col="blue",cex=0.2)
#cex regula o tamaño dos puntos representados

# Pódese engadir unha recta de regresión, co comando *abline()* indicando como parámetro un comando que realice a regresión:
abline(lm(auxiliar$Y~auxiliar$X1),col="red")

#Con ggplot2: http://www.cookbook-r.com/Graphs/Scatterplots_(ggplot2)/
ggplot(auxiliar, aes(x=X1, y=Y)) +
    geom_point(shape=20,col="blue") + ylim(-3,12)   +
    geom_smooth(method=lm,col="red",cex=0.2)+ labs(title = "Y vs X1",x="Explicativa X1",y="Explicada Y") +
    theme_bw()    




## -------------------------------------------------------------------------------------
plot(auxiliar,pch=20,col="blue",cex=0.2)
#cex regula o tamaño dos puntos representados


#Con ggplot2 úsase un paquete diferente GGally
library(GGally)
ggpairs(auxiliar,columns=c(2,3,4)) +
    theme_bw()    #Hai que seguir explorando




## -------------------------------------------------------------------------------------
#coeficiente de correlación simple
cor(auxiliar$X1,auxiliar$Y)
cor(auxiliar[c(2:4)])
#contraste
cor.test(auxiliar$X1,auxiliar$Y)
#library psych para matriz de contrastes

corr.test(auxiliar[c(2:4)], use = "complete", method = "pearson")#library("psych")

corrgram(auxiliar[c(2:4)])#library(corrgram)
corrgram(auxiliar[c(2:4)], lower.panel=panel.pts, upper.panel=panel.conf,
         diag.panel=panel.density)


## -------------------------------------------------------------------------------------
library("ppcor")
pcor.test(auxiliar$X1,auxiliar$Y,auxiliar[c(3,4)])


## -------------------------------------------------------------------------------------
lm(Y~X1+X2+X3)


## -------------------------------------------------------------------------------------
summary(lm(Y~X1+X2+X3))


## -------------------------------------------------------------------------------------
regresion=lm(Y~X1+X2+X3)
summary(regresion)



## -------------------------------------------------------------------------------------
#como ver o que ten ese obxecto: mirando os nomes dos seus elementos, algúns sonaranvos só con velos
names(regresion)
#O summary deste comando produce un obxecto diferente. 
# Observade tamén, neste caso, como trata a variable cyl se a consideramos un factor
(regresion2=summary(lm(Y~.,data=auxiliar)))
names(regresion2)


## -------------------------------------------------------------------------------------
regresion$coefficients#os coeficientes
coefficients(regresion)#que tamén teñen comando propio
regresion2$adj.r.squared#R2 axustado


## -------------------------------------------------------------------------------------
#uso o obxecto auxiliar, que é un data.frame
# apply está pensado para matrices de R, pero tamén funciona con data.frames
  
#media aritmética por columnas
apply(auxiliar,2,mean)
#media aritmética por filas
apply(auxiliar,1,mean)
#desviación típica por filas
apply(auxiliar,1,sd)
#liala un pouco, introducir na matriz unha fila que só teña NA's, para que non funcione ben mean ou sd
auxiliarNA=rbind(auxiliar,rep(NA,3))


## -------------------------------------------------------------------------------------
apply(auxiliarNA,2,function(x) mean(x,na.rm = T))


## -------------------------------------------------------------------------------------
# #funcion gorda
# cousas=function(X){
#   mda=mean(X,na.rm = T)
#   d.t.=sd(X,na.rm = T)
#   c(mda,d.t.)
# }
# apply(auxiliar,2,cousas)
# apply(auxiliar,1,cousas)


## -------------------------------------------------------------------------------------
lapply(auxiliar,mean)
# lapply(auxiliar,cousas)


## -------------------------------------------------------------------------------------
sapply(auxiliar,mean)
# sapply(auxiliar,cousas)


## -------------------------------------------------------------------------------------
#Como son estas saidas
str(sapply(auxiliar,mean))
str(lapply(auxiliar,mean))

